<project xmlns="http://maven.apache.org/POM/4.0.0"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>

	<groupId>com.webengage</groupId>
	<artifactId>api-automation</artifactId>
	<version>0.0.1-SNAPSHOT</version>
	<packaging>jar</packaging>

	<name>api-automation</name>
	<url>http://maven.apache.org</url>

	<properties>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<java.version>1.8</java.version>
		<junit.version>4.13.2</junit.version>
		<cucumber.version>6.10.4</cucumber.version>
		<restassured.version>4.4.0</restassured.version>
		<serenity.version>2.4.25</serenity.version>
		<serenity.maven.version>2.3.12</serenity.maven.version>
		<serenity.cucumber.version>2.4.24</serenity.cucumber.version>
		<gson.version>2.8.6</gson.version>
		<apache.poi.version>5.0.0</apache.poi.version>
		<maven.compiler.version>3.8.1</maven.compiler.version>
		<maven.surefire.version>2.22.2</maven.surefire.version>
	</properties>

	<dependencies>
		<dependency>
			<groupId>junit</groupId>
			<artifactId>junit</artifactId>
			<version>${junit.version}</version>
		</dependency>
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-junit</artifactId>
			<version>${cucumber.version}</version>
		</dependency>
		<dependency>
			<groupId>io.cucumber</groupId>
			<artifactId>cucumber-java</artifactId>
			<version>${cucumber.version}</version>
		</dependency>
		<dependency>
			<groupId>com.google.code.gson</groupId>
			<artifactId>gson</artifactId>
			<version>${gson.version}</version>
		</dependency>
		<dependency>
			<groupId>org.apache.poi</groupId>
			<artifactId>poi</artifactId>
			<version>${apache.poi.version}</version>
		</dependency>
		<dependency>
			<groupId>org.apache.poi</groupId>
			<artifactId>poi-ooxml</artifactId>
			<version>${apache.poi.version}</version>
		</dependency>
		<dependency>
			<groupId>org.testng</groupId>
			<artifactId>testng</artifactId>
			<version>7.7.1</version>
		</dependency>
		<dependency>
			<groupId>com.googlecode.json-simple</groupId>
			<artifactId>json-simple</artifactId>
			<version>1.1.1</version>
		</dependency>
		<dependency>
			<groupId>net.masterthought</groupId>
			<artifactId>maven-cucumber-reporting</artifactId>
			<version>5.5.0</version>
		</dependency>
		<dependency>
			<groupId>net.serenity-bdd</groupId>
			<artifactId>serenity-cucumber6</artifactId>
			<version>${serenity.cucumber.version}</version>
		</dependency>
		<dependency>
			<groupId>net.serenity-bdd</groupId>
			<artifactId>serenity-core</artifactId>
			<version>${serenity.version}</version>
			<exclusions>
				<exclusion>
					<groupId>io.cucumber</groupId>
					<artifactId>cucumber-core</artifactId>
				</exclusion>
			</exclusions>
		</dependency>
		<dependency>
			<groupId>net.serenity-bdd</groupId>
			<artifactId>serenity-rest-assured</artifactId>
			<version>${serenity.cucumber.version}</version>
		</dependency>
		<dependency>
			<groupId>net.serenity-bdd</groupId>
			<artifactId>serenity-junit</artifactId>
			<version>${serenity.cucumber.version}</version>
		</dependency>
		<dependency>
			<groupId>org.projectlombok</groupId>
			<artifactId>lombok</artifactId>
			<version>1.18.20</version>
			<scope>provided</scope>
		</dependency>
		<dependency>
			<groupId>net.serenity-bdd</groupId>
			<artifactId>serenity-jira-plugin</artifactId>
			<version>1.12.0</version>
		</dependency>
		<dependency>
			<groupId>mysql</groupId>
			<artifactId>mysql-connector-java</artifactId>
			<version>8.0.27</version>
		</dependency>
		<dependency>
			<groupId>com.zaxxer</groupId>
			<artifactId>HikariCP</artifactId>
			<version>4.0.3</version>
		</dependency>
		<dependency>
			<groupId>org.apache.logging.log4j</groupId>
			<artifactId>log4j-slf4j-impl</artifactId>
			<version>2.17.1</version>
			<scope>test</scope>
		</dependency>
		<dependency>
			<groupId>org.slf4j</groupId>
			<artifactId>slf4j-api</artifactId>
			<version>1.7.30</version>
		</dependency>


	</dependencies>
	<profiles>
		<profile>
			<id>apiTest</id>
			<activation>
				<activeByDefault>true</activeByDefault>
			</activation>
			<build>
				<plugins>
					<plugin>
						<groupId>org.codehaus.mojo</groupId>
						<artifactId>exec-maven-plugin</artifactId>
						<version>3.0.0</version>
						<configuration>
							<mainClass>com.webengage.api_automation.initialize.Initializer</mainClass>
						</configuration>
					</plugin>
					<plugin>
						<groupId>org.apache.maven.plugins</groupId>
						<artifactId>maven-compiler-plugin</artifactId>
						<version>${maven.compiler.version}</version>
						<configuration>
							<source>${java.version}</source>
							<target>${java.version}</target>
						</configuration>
					</plugin>
					<plugin>
						<groupId>org.apache.maven.plugins</groupId>
						<artifactId>maven-surefire-plugin</artifactId>
						<version>${maven.surefire.version}</version>
						<configuration>
							<testFailureIgnore>true</testFailureIgnore>
							<includes>
								<include>**/*Runner.java</include>
							</includes>
							<systemPropertiesFile>src/test/resources/testData/buildCucumberOptions.properties</systemPropertiesFile>
						</configuration>
						<dependencies>
							<dependency>
								<groupId>org.apache.maven.surefire</groupId>
								<artifactId>surefire-junit47</artifactId>
								<version>2.10</version>
							</dependency>
						</dependencies>
					</plugin>
					<plugin>
						<groupId>net.masterthought</groupId>
						<artifactId>maven-cucumber-reporting</artifactId>
						<version>5.5.0</version>
						<executions>
							<execution>
								<id>execution</id>
								<phase>verify</phase>
								<goals>
									<goal>generate</goal>
								</goals>
								<configuration>
									<projectName>api-automation</projectName>
									<skip>false</skip>
									<outputDirectory>${project.build.directory}</outputDirectory>
									<inputDirectory>${project.build.directory}/cucumber-reports</inputDirectory>
									<jsonFiles>
										<param>**/*.json</param>
									</jsonFiles>
								</configuration>
							</execution>
						</executions>
					</plugin>
					<plugin>
						<groupId>net.serenity-bdd.maven.plugins</groupId>
						<artifactId>serenity-maven-plugin</artifactId>
						<version>${serenity.cucumber.version}</version>
						<configuration>
							<tags>${tags}</tags>
						</configuration>
						<dependencies>
							<dependency>
								<groupId>net.serenity-bdd</groupId>
								<artifactId>serenity-core</artifactId>
								<version>${serenity.version}</version>
							</dependency>
						</dependencies>
						<executions>
							<execution>
								<id>serenity-reports</id>
								<phase>post-integration-test</phase>
								<goals>
									<goal>aggregate</goal>
								</goals>
							</execution>
						</executions>
					</plugin>
				</plugins>
			</build>
		</profile>
		<profile>
			<id>analyticsTest</id>
			<build>
				<pluginManagement>
					<!-- lock down plugins versions to avoid using Maven 
				defaults (maybe moved to parent pom) -->
					<plugins>
						<!-- clean lifecycle, see https://maven.apache.org/ref/current/maven-core/lifecycles.html#clean_Lifecycle -->
						<plugin>
							<artifactId>maven-clean-plugin</artifactId>
							<version>3.1.0</version>
						</plugin>
						<!-- default lifecycle, jar packaging: see https://maven.apache.org/ref/current/maven-core/default-bindings.html#Plugin_bindings_for_jar_packaging -->
						<plugin>
							<artifactId>maven-resources-plugin</artifactId>
							<version>3.0.2</version>
						</plugin>
						<plugin>
							<artifactId>maven-compiler-plugin</artifactId>
							<version>3.8.0</version>
						</plugin>
						<plugin>
							<artifactId>maven-surefire-plugin</artifactId>
							<version>2.22.1</version>
						</plugin>
						<plugin>
							<artifactId>maven-jar-plugin</artifactId>
							<version>3.0.2</version>
						</plugin>
						<plugin>
							<artifactId>maven-install-plugin</artifactId>
							<version>2.5.2</version>
						</plugin>
						<plugin>
							<artifactId>maven-deploy-plugin</artifactId>
							<version>2.8.2</version>
						</plugin>
						<!-- site lifecycle, see https://maven.apache.org/ref/current/maven-core/lifecycles.html#site_Lifecycle -->
						<plugin>
							<artifactId>maven-site-plugin</artifactId>
							<version>3.7.1</version>
						</plugin>
						<plugin>
							<artifactId>maven-project-info-reports-plugin</artifactId>
							<version>3.0.0</version>
						</plugin>
					</plugins>
				</pluginManagement>
				<plugins>
					<plugin>
						<groupId>org.apache.maven.plugins</groupId>
						<artifactId>maven-compiler-plugin</artifactId>
						<configuration>
							<source>1.8</source>
							<target>1.8</target>
						</configuration>
					</plugin>
					<plugin>
						<groupId>org.apache.maven.plugins</groupId>
						<artifactId>maven-surefire-plugin</artifactId>
						<configuration>
							<suiteXmlFiles>${suiteXmlFile}</suiteXmlFiles>
						</configuration>
					</plugin>
				</plugins>
			</build>
		</profile>
	</profiles>

</project>
